       program-id.  test-grid.

       input-output section.
       file-control.
       select filegrid assign to random "grd"
              organization indexed access dynamic record key f-key.

       file section.
       fd  filegrid.
       01  f-rec.
           03 f-key       pic x(2).
           03 f-type      pic x(13).
           03 f-author    pic x(15).
           03 f-title     pic x(20).

       working-storage section.
       copy "isgui.def".
       copy "iscrt.def".
       01  i       pic 9(18).
       77  key-status pic 9(5) special-names crt status.

       screen section.
       01  main-screen.
           03 grid-1 grid 
                   paged 
                   line 2 
                   col 2 
                   size 68 
                   cells lines 4
                   data-columns (1, 3, 16, 31)
                   display-columns (1, 4, 18, 42)
                   event GRID-1-EVENT.
           03 push-button 
                   line 9.5 
                   col 40 
                   size 20
                   exception-value 101 
                   "action-current-page".

       procedure division.
       MAIN-LOGIC.
           display standard graphical window background-low
                   size 70 lines 11
           open input filegrid
           display main-screen
           perform load-grid
           perform until key-status = 27
              accept  main-screen on exception
              continue end-accept
              evaluate key-status
              when 101 perform current-page
              end-evaluate
           end-perform.
           close   filegrid
           destroy main-screen
           goback
           .

       LOAD-GRID.
           move "01" to f-key
           start filegrid key is = f-key
           modify grid-1 action = ACTION-CURRENT-PAGE
           .
           
       CURRENT-PAGE.
           move "07" to f-key
           start filegrid key is = f-key
           modify grid-1 action = ACTION-CURRENT-PAGE
           .           

       GRID-1-EVENT.
           evaluate event-type
           when MSG-PAGED-NEXT   perform GRID-1-NEXT
           when MSG-PAGED-PREV   perform GRID-1-PREV
           when MSG-PAGED-FIRST  perform GRID-1-FIRST
           when MSG-PAGED-LAST   perform GRID-1-LAST
           WHEN MSG-BEGIN-ENTRY
                set event-action to event-action-fail
           END-EVALUATE
           .
        
       GRID-1-FIRST.
           move low-value to f-key
           start filegrid key not less f-key
             invalid set event-action to event-action-fail
           end-start
           .

       GRID-1-LAST.
           move high-value to f-key
           start filegrid key <= f-key
              invalid set event-action to event-action-fail
           end-start
           .

       GRID-1-NEXT.
           perform event-data-2 times
              read filegrid next
                 at end set event-action to event-action-fail 
                        exit paragraph
              end-read
           end-perform
           modify grid-1 record-to-add = f-rec
           .

       GRID-1-PREV.
           perform event-data-2 times
              read filegrid previous
                 at end set event-action to event-action-fail 
                        exit paragraph
              end-read
           end-perform
           modify grid-1 insertion-index = 1
                         record-to-add   = f-rec
           .